<script lang="ts">
  import Button from "./Button.svelte";
</script>

<main class="main">
  <h1 class="heading">Buttons</h1>

  <div class="buttons">
    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button color="default" />'}
        </h2>
        <Button color="default" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button color="primary" />'}
        </h2>
        <Button color="primary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button color="secondary" />'}
        </h2>
        <Button color="secondary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button color="danger" />'}
        </h2>
        <Button color="danger" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="outline" />'}
        </h2>
        <Button variant="outline" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="outline" color="primary" />'}
        </h2>
        <Button variant="outline" color="primary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="outline" color="secondary" />'}
        </h2>
        <Button variant="outline" color="secondary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="outline" color="danger" />'}
        </h2>
        <Button variant="outline" color="danger" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" />'}
        </h2>
        <Button variant="text" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" color="primary" />'}
        </h2>
        <Button variant="text" color="primary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" color="secondary" />'}
        </h2>
        <Button variant="text" color="secondary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" color="danger" />'}
        </h2>
        <Button variant="text" color="danger" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {"<Button disableShadow />"}
        </h2>
        <Button disableShadow />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button disableShadow color="primary" />'}
        </h2>
        <Button disableShadow color="primary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button disableShadow color="secondary" />'}
        </h2>
        <Button disableShadow color="secondary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button disableShadow color="danger" />'}
        </h2>
        <Button disableShadow color="danger" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {"<Button disabled />"}
        </h2>
        <Button disabled />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button disabled color="primary" />'}
        </h2>
        <Button disabled color="primary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button disabled color="secondary" />'}
        </h2>
        <Button disabled color="secondary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button disabled color="danger" />'}
        </h2>
        <Button disabled color="danger" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" disabled />'}
        </h2>
        <Button variant="text" disabled />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" disabled color="primary" />'}
        </h2>
        <Button variant="text" disabled color="primary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" disabled color="secondary" />'}
        </h2>
        <Button variant="text" disabled color="secondary" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button variant="text" disabled color="danger" />'}
        </h2>
        <Button variant="text" disabled color="danger" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button startIcon="local_grocery_store" />'}
        </h2>
        <Button startIcon="local_grocery_store" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button endIcon="local_grocery_store" />'}
        </h2>
        <Button endIcon="local_grocery_store" />
      </section>
    </div>

    <div class="buttons__row">
      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button size="sm" />'}
        </h2>
        <Button size="sm" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button size="md" />'}
        </h2>
        <Button size="md" />
      </section>

      <section class="showcase">
        <h2 class="showcase__heading">
          {'<Button size="lg" />'}
        </h2>
        <Button size="lg" />
      </section>
    </div>
  </div>

  <p class="icons-source">
    <span>Icons:</span>
    <a
      href="https://material.io/resources/icons/?style=round"
      class="icons-source__link"
    >
      https://material.io/resources/icons/?style=round
    </a>
  </p>
</main>

<style lang="scss">
  @font-face {
    font-family: Poppins;
    src: url("assets/fonts/Poppins-Medium.ttf") format("truetype");
    font-weight: 500;
    display: swap;
  }

  @font-face {
    font-family: "Ubuntu Mono";
    src: url("assets/fonts/UbuntuMono-Regular.ttf") format("truetype");
    font-weight: 400;
    display: swap;
  }

  @font-face {
    font-family: "Noto Sans JP";
    src: url("assets/fonts/NotoSansJP-Medium.otf") format("opentype");
    font-weight: 500;
    display: swap;
  }

  :root {
    --font-default: "Poppins", system-ui, -apple-system, blinkmacsystemfont,
      "Segoe UI", roboto, oxygen, ubuntu, cantarell, "Open Sans",
      "Helvetica Neue", sans-serif;
    --font-mono: "Ubuntu Mono", "Courier New", courier, monospace;
    --font-button: "Noto Sans JP", system-ui, -apple-system, blinkmacsystemfont,
      "Segoe UI", roboto, oxygen, ubuntu, cantarell, "Open Sans",
      "Helvetica Neue", sans-serif;
  }

  .main {
    margin: 0;
    padding: 5rem 10rem calc(5rem + env(safe-area-inset-bottom));

    @media only screen and (max-width: 46.875em) {
      padding: 4rem 8rem calc(4rem + env(safe-area-inset-bottom));
    }

    @media only screen and (max-width: 37.5em) {
      padding: 2rem 4rem calc(2rem + env(safe-area-inset-bottom));
    }

    @media only screen and (max-width: 18.75em) {
      padding: 1rem 2rem calc(1rem + env(safe-area-inset-bottom));
    }
  }

  .buttons {
    margin: 0;
    padding: 0;
    display: flex;
    flex-direction: column;
    gap: 8rem;
    margin-bottom: 5.2rem;
    font-family: var(--font-button);
    font-size: 1.4rem;
    font-weight: 500;
    line-height: 1.45;

    @media only screen and (max-width: 46.875em) {
      gap: 6rem;
    }

    @media only screen and (max-width: 18.75em) {
      gap: 4rem;
    }

    &__row {
      margin: 0;
      padding: 0;
      display: flex;
      align-items: flex-end;
      flex-wrap: wrap;
      column-gap: 6rem;
      row-gap: 4rem;

      @media only screen and (max-width: 46.875em) {
        column-gap: 5rem;
        row-gap: 3rem;
      }

      @media only screen and (max-width: 37.5em) {
        column-gap: 4rem;
        row-gap: 2rem;
      }

      @media only screen and (max-width: 18.75em) {
        column-gap: 2rem;
        row-gap: 1rem;
      }
    }
  }

  .heading {
    margin: 0;
    padding: 0;
    font-family: var(--font-default);
    font-size: 2.4rem;
    font-weight: 500;
    line-height: 1.5;
    color: #4f4f4f;
    margin-bottom: 2.8rem;
  }

  .showcase {
    margin: 0;
    padding: 0;
    flex-basis: min-content;

    &__heading {
      margin: 0;
      padding: 0;
      font-family: var(--font-mono);
      font-size: 1.2rem;
      line-height: 1;
      color: #828282;
      margin-bottom: 1.2rem;
    }
  }

  .icons-source {
    margin: 0;
    padding: 0;
    font-family: var(--font-mono);
    font-size: 1.2rem;
    line-height: 1;
    color: #828282;

    &__link {
      text-decoration: none;

      &:visited {
        color: #828282;
      }

      &:hover,
      &:focus,
      &:active {
        outline: none;
        text-decoration: underline;
        text-decoration-thickness: 0.2rem;
      }
    }
  }
</style>
